var g_ML_Debug;
var g_ML_Debug_inout = "";
var g_ML_Debug_state = "";

var g_ML_prev_text_struct = ml_text_struct_ctor(0, 0, 0, "");
var g_ML_cur_text_struct = ml_text_struct_ctor(0, 0, 0, "");

var g_ML_Timer = 0;


function ml_text_struct_ctor( posx, posy, stringpoint, stringvalue ){
   // javascript style struct ctor
   this.posx = posx;
   this.posy = posy;
   this.stringpoint = stringpoint;
   this.stringvalue = stringvalue;
   if (this.stringpoint >= this.stringvalue.length){
       this.stringpoint = -1;
   }
}

function ml_get_wait_time(){
   return 350; // 350 is a reasonable default
}

function ml_get_IMLTrigger(){
   // get XPCOM ptr to native (C++) code
   netscape.security.PrivilegeManager.enablePrivilege(
      "UniversalXPConnect");
   const cid = "@morphologic.hu/MLTrigger";

   trigger = Components.classes[cid].createInstance();
   trigger = trigger.QueryInterface(Components.interfaces.IMLTrigger);
   return trigger;
}

function ml_mouseout(evt){
   try{
      // if mouse leaves the browser
      g_ML_Debug_state = "OK";

      if( evt.relatedTarget == null ){
         trigger = ml_get_IMLTrigger();
       
         // new API:
         trigger.Invalidate_text();

         // old (trigger-subscriber) API:
         // send mouseout to subscriber
         trigger.Send_mouse_inout( true ); // true == out
         
         // old (trigger-subscriber) API:                <label id="text_under_mouse_label_cursor" value="x"/>
         // kill previous timer
         g_ML_cur_text_struct.posx = -100;
         g_ML_cur_text_struct.posy = -100;
         ml_kill_prev_timer();

         g_ML_Debug_inout = "Out";
         ml_write_debug_info();
      }
   }
   catch(e){
      g_ML_Debug_state = "Exception: " + e;
      ml_write_debug_info();
   }
   // returning false allows other event handlers to deal with this event
   return false;
}

function ml_mouseover(evt){
   try{
      // if mouse enters the browser

      g_ML_Debug_state = "OK";

      if( evt.relatedTarget == null ){

         // old (trigger-subscriber) API:
         // send mousein to subscriber
         trigger = ml_get_IMLTrigger();
         trigger.Send_mouse_inout( false ); // false == in
         
         g_ML_Debug_inout = "In";
         ml_write_debug_info();
      }
   }
   catch(e){
      g_ML_Debug_state = "Exception: " + e;
      ml_write_debug_info();
   }
   // returning false allows other event handlers to deal with this event
   return false;
}



function ml_mousemove(evt){
   try{
      // if mouse moves in the browser



      g_ML_Debug_state = "OK";
      
      // get text info
      text_struct = ml_get_text_under_mouse(evt);

      g_ML_prev_text_struct = g_ML_cur_text_struct;
      g_ML_cur_text_struct = text_struct;

      trigger = ml_get_IMLTrigger();
      // new API: store text in shared mem
      trigger.Store_text(text_struct.stringvalue, text_struct.stringpoint);

      // start timer for old (trigger-subscriber) API,
      // trigger only if mouse waits here for a while
      ml_start_timer();
      
      ml_write_debug_info();
   }
   catch(e){
      trigger = ml_get_IMLTrigger();
      trigger.Invalidate_text();

      g_ML_Debug_state = "Exception: " + e;
      ml_write_debug_info();
   }
   // returning false allows other event handlers to deal with this event
   return false;
}


/*

getBoxObjectFor

function getCoords (element) {
var coords = { x: 0, y: 0, width: element.offsetWidth, height:
element.offsetHeight };
while (element) {
coords.x += element.offsetLeft;
coords.y += element.offsetTop;
element = element.offsetParent;
}
return coords;
}
*/

// http://home.arcor.de/martin.honnen/javascript/2009/04/test2009040501.html
function checkBoundingRect(PosX, PosY, obj){
    //trial by ei
    //check nearest node's coordinates: mouse is under that rectangle?
    //var rectX, rectY, rectW, rectH;
    //rectX = rectY = 0;
    
    if (obj && typeof obj.getBoundingClientRect != 'undefined'){
        var rect = obj.getBoundingClientRect(); //getClientRects();//
        /*
        if(mynode.x) rectX = mynode.x;
        if(mynode.y) rectY = mynode.y;
        if (mynode.offsetWidth) rectW = mynode.offsetWidth;
        if (mynode.offsetHeight) rectH = mynode.offsetHeight;
        */

        //g_ML_Debug_state = "HAHO  ["+PosX+","+PosY+"] " + rect.left + " " + rect.top + "x" + rect.right + " " + rect.bottom; 
        if (PosX < rect.left || PosX > rect.left+rect.right ||
            PosY < rect.top || PosY > rect.top+rect.bottom)
            return false; //it is not hit
        else
            return true; //it is hit
    }
    return true; //for thunderbird
}

function ml_get_text_under_mouse(evt)
{
   var PosX;
   var PosY;
   var StringPoint;
   var StringValue;
   
   if( evt ){
      // retrive the data we need
      PosX = evt.clientX; // coord x
      PosY = evt.clientY; // coord y

      // the string itself
      if( evt.rangeParent && evt.rangeOffset && document.createRange){
         var mynode = evt.rangeParent;  // nearest node
         var myrange = document.createRange();
         
         StringPoint = evt.rangeOffset-1; // pos in node
         StringValue = "";              // text of node
         
         //check nearest node's coordinates: mouse is under that rectangle?
         if (typeof mynode.data == 'undefined' || !checkBoundingRect(PosX, PosY, evt.target)) throw 1; //it's not hit...

         while (mynode.nodeType != mynode.ELEMENT_NODE){
            for( var sib = mynode.previousSibling; sib != null;
                 sib = sib.previousSibling)
            {
               var tmprange = document.createRange();
               tmprange.selectNode(sib);
               StringPoint += tmprange.toString().length;
            }
            mynode = mynode.parentNode;
         }

         if(mynode.hasChildNodes()){
            myrange.setStartBefore( mynode );
            myrange.setEndAfter( mynode );
         }
         else
         {
            myrange.setStart( evt.rangeParent, 0 );
            myrange.setEnd( evt.rangeParent, evt.rangeParent.length );
            
         }
         
         StringValue += myrange.toString();
         myrange.detach();
         
      }
   }
   else{
      throw 1;
   }
   
   cur_text_struct = new ml_text_struct_ctor( PosX, PosY, StringPoint,
                                              StringValue );
   return cur_text_struct;
   
}

function ml_kill_prev_timer(){
   if(g_ML_Timer != 0){
      //allow 5x5 pixel moving without reseting
      if((Math.abs(g_ML_cur_text_struct.posx-g_ML_prev_text_struct.posx)>5)
         ||
         (Math.abs(g_ML_cur_text_struct.posx-g_ML_prev_text_struct.posy)>5))
      {
         window.clearTimeout(g_ML_Timer);
         g_ML_Timer = 0;
      }
   }
}

function ml_start_timer(){
   // kill the previously launched ml_send_text, and
   
   ml_kill_prev_timer();
   
   // launch a new one to be started with a little delay
   if(g_ML_Timer == 0){
      // on timeout ml_send_text will be called
      g_ML_Timer = window.setTimeout("ml_on_timeout()", ml_get_wait_time());
      
      g_ML_Debug_state = "Called";
      ml_write_debug_info();
   }
   return false;
}

function ml_on_timeout(){
   // called when timer (launched in ml_start_timer) timeouts
   ml_send_text();
}

function ml_send_text()
{
   // old (trigger-subscriber) API:
   // send text to subscriber through C++ code,
   // usually called from ml_on_timeout
   try
   {
      g_ML_Timer = 0;

      // fire
      trigger = ml_get_IMLTrigger();
      if(g_ML_cur_text_struct.stringvalue != undefined){
         trigger.Send16(g_ML_cur_text_struct.stringvalue,
                        g_ML_cur_text_struct.stringpoint,
                        g_ML_cur_text_struct.posx,
                        g_ML_cur_text_struct.posy);
      }
      
      g_ML_Debug_state = "Fired";
      ml_write_debug_info();
   }
   catch(e)
   {
      g_ML_Debug_state = "Exception: " + e;
      ml_write_debug_info();
   }
   
   return false;
}

function ml_write_debug_info(){
   if(g_ML_Debug){
      document.getElementById('text_under_mouse_label_xy'
                             ).setAttribute("value", "["
                                            + g_ML_cur_text_struct.posx + ","
                                            + g_ML_cur_text_struct.posy + "]");
      document.getElementById('text_under_mouse_label_pos'
                             ).setAttribute("value", ":"
                                    + g_ML_cur_text_struct.stringpoint + "/"
                                    + g_ML_cur_text_struct.stringvalue.length);
      document.getElementById('text_under_mouse_label_string'
                             ).setAttribute("value",
                                   g_ML_cur_text_struct.stringvalue.substring(
                                     Math.max(0,
                                       g_ML_cur_text_struct.stringpoint-30),
                                     Math.min(
                                       g_ML_cur_text_struct.stringvalue.length,
                                       g_ML_cur_text_struct.stringpoint+30)));
      document.getElementById('text_under_mouse_label_act'
                             ).setAttribute("value", (g_ML_Timer?"Timer":""));
      document.getElementById('text_under_mouse_label_inout'
                             ).setAttribute("value", g_ML_Debug_inout);
      document.getElementById('text_under_mouse_label_state'
                             ).setAttribute("value", g_ML_Debug_state);

   }
}


// former attemts to retrive the text... 

// 3rd

// filter out texts that are far but caught
// if( myrange.commonAncestorContainer.parentNode.tagName ==
//     "INPUT" ||
//     myrange.commonAncestorContainer.parentNode.tagName ==
//     evt.target.tagName )

// 2nd

// var myrange = document.createRange();
// myrange.selectNodeContents(evt.target);

// 1st

// //text
// var s = "";
// try{
//    if( evt.target.tagName == "INPUT" ){
//       if( evt.target.hasAttribute("value") ){
//       s = evt.target.getAttribute(
//          "value");
//       }
//    }
//    else{
//       if( evt.target.nodeType == 1 ){
//       // ELEMENT_NODE
//       var nodechildren =
//          evt.target.childNodes;
//       for( var i=0;
//            i<nodechildren.length;
//            ++i )
//       {
//          if( nodechildren[i
//                          ].nodeType == 3)
//          { // TEXT_NODE
//             s +=
//             nodechildren[i
//                         ].nodeValue;
//          }
//          else if( nodechildren[i
//                               ].nodeType==1
//                   // ELEMENT_NODE 
//                   &&
//                   nodechildren[i
//                               ].tagName ==
//                   "A" ) // && link
//             // TODO: bold, color, etc.
//             {
//                // avoiding shit content
//                if(nodechildren[
//                   i].firstChild 
//                   && nodechildren[
//                      i].firstChild.nodeType == 3 )
//                   // TEXT_NODE
//                {
//                   s += nodechildren[i].firstChild.nodeValue;
//                }
//             }
//       }
//       }
//    }
// }catch(e){ alert(e.description); }

